<template>
  <div :id="$attachReactablePostfix('login_wrapper')" class="bt-container">
    <el-container>
      <el-row>
        <el-col>
          <!-- TODO: add form html element -->
          <!-- TODO: add validation -->
          <h1>{{ $t("LOGIN.LOGIN_TITLE") }}</h1>
          <!-- 뒤로가기 추가 -->
          <div style="display:inline; float: right;">
            <a href="javascript:history.back();">
              <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
            </a>
          </div> 
          <span v-if="redirectTo" style="color:red">{{
            $t("LOGIN.LOGIN_REQUIRED")
          }}</span>

          <el-input
            class="LoginEmail"
            placeholder="abc@gmail.com"
            v-model="input.email"
            type="email"
          >
            <template slot="prepend">{{ $t("LOGIN.EMAIL_LABEL") }}</template>
          </el-input>
          <el-input
            class="LoginPassword"
            placeholder="********"
            v-model="input.password"
            type="password"
            @keydown.enter.native="onClick('LOGIN')"
          >
            <template slot="prepend">{{ $t("LOGIN.PASSWORD_LABEL") }}</template>
          </el-input>
          <br />
          <br />
          <!-- TODO: add disabled attr according to validation -->
          <el-button
            :id="$attachReactablePostfix('btn_login', 'LoginLoginBtn')"
            type="primary"
            @click="onClick('LOGIN')"
          >
            {{ $t("LOGIN.LOGIN_BUTTON") }}
          </el-button>
          <el-button
            type="primary"
            @click="onClick('FORGOT_PASSWORD', 'LoginForgotPassword')"
          >
            {{ $t("LOGIN.FORGOT_PASSWORD_BUTTON") }}
          </el-button>
          <el-dialog
            :title="$t('LOGIN.LOGIN_REQUIRED')"
            :visible.sync="isModalVisible"
            :width="$isPhone ? '80%' : '30%'"
            center
          >
            <!-- TODO: replace 브랜드 로고 -->
            <!--<el-button type="primary" plain slot="title">Brand Logo</el-button>-->
            <!-- <h2>비밀번호 변경</h2> 
            <span>비밀번호를 변경할 이메일을 입력하세요.</span>
            <br/><br/><hr><br/>
            -->
            <el-form :model="input" label-width="120px" label-position="top">
              <el-form-item :label="$t('LOGIN.CHANGE_PASSWORD_EMAIL')">
                <el-input
                  v-model="findingPasswordEmail"
                  class="LoginFindingPasswordEmail"
                ></el-input>
              </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
              <el-button
                type="primary"
                @click="onClick('SUBMIT')"
                class="LoginSendTemporaryPassword"
              >
                {{ $t("LOGIN.SEND_CHANGE_PASSWORD_METHOD") }}
              </el-button>
            </span>
          </el-dialog>
        </el-col>
      </el-row>
    </el-container>
    <!-- jwt: {{ jwt }} <br />
    input: {{ input }} <br />
    redirectTo: {{ redirectTo }} -->
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import userService from "../../services/userService";

export default {
  name: "Login",
  data() {
    return {
      input: {
        email: "teacher1",
        password: "test"
        // email: "",
        // password: ""
      },
      isModalVisible: false,
      findingPasswordEmail: ""
    };
  },
  methods: {
    ...mapActions("auth", ["reqLogin", "findPassword"]),
    async onClick(type) {
      const vm = this;
      switch (type) {
        case "LOGIN": {
          try {
            const res = await vm.reqLogin({
              email: vm.input.email,
              password: vm.input.password
            });
            // const jwt = vm.$store.state.auth.jwt;
            // console.log('vm.$store.state.auth.jwt222; = ', vm.$store.state.auth.jwt);
            // console.log('utils.getAuthTypeFromJwt(jwt) = ', utils.getAuthTypeFromJwt(jwt));
            // console.log('login res', JSON.stringify(res));
            // TODO: translate

            // vm.openNoti('success', 'Login Success !!', 'Success');
            if (res.data.terms === 0) {
              vm.$router.push("/tos");
            } else if (vm.redirectTo) {
              // jwt 업데이트 후 페이지 이동 이루어지도록
              vm.$router.push(vm.redirectTo);
            } else {
              vm.$router.push("/");
            }
          } catch (error) {
            if (error.response.status === 403) {
              vm.$notify({
                title: "warning",
                message: vm.$t("NOTIFY.ACCNT_NOT_EXIST"),
                type: "warning",
                duration: 5000
              });
            } else if (error.response.status === 406) {
              vm.$notify({
                title: "Sorry",
                message: vm.$t("NOTIFY.INCORR_PSWRD"),
                type: "warning",
                duration: 5000
              });
            } else {
              vm.$notify({
                title: "Sorry",
                message:
                  error.response !== undefined
                    ? error.response.data.message
                    : error.message, //eslint-disable-line
                type: "warning",
                duration: 5000
              });
            }
            // console.dir(error);
          }
          break;
        }
        case "FORGOT_PASSWORD": {
          vm.isModalVisible = true;
          break;
        }
        case "SUBMIT": {
          try {
            await vm.findPassword({
              email: vm.findingPasswordEmail
            });
            vm.$notify({
              title: vm.$t("NOTIFY.EMAIL_SENT"),
              message: vm.$t("NOTIFY.PSWRD_RESET_SENT"),
              type: "success"
            });
            vm.isModalVisible = false;
          } catch (error) {
            vm.$notify({
              title: vm.$t("NOTIFY.FAIL_EMAIL_SENT"),
              message: error.toString(),
              type: "error",
              duration: 0
            });
          }
          break;
        }
        default: {
          throw new Error("not defined type", type);
        }
      }
    },
    openNoti(type, message, title) {
      const vm = this;
      switch (type) {
        case "success":
        case "warning":
          vm.$notify({
            title,
            message,
            type
          });
          break;
        default:
        case "error": {
          vm.$notify.error({
            title: "Error",
            message
          });
          break;
        }
      }
    }
  },
  computed: {
    ...mapState("auth", ["jwt"]),
    redirectTo() {
      const vm = this;
      return vm.$route.params.to;
    }
  },
  mounted() {
    const vm = this;
    if (vm.redirectTo) {
      vm.openNoti("warning", vm.$t("LOGIN.LOGIN_REQUIRED"), "Warning");
    }
    if (vm.$route.query.alert === "expired") {
      vm.$notify({
        title: "warning",
        message: vm.$t("NOTIFY.LOGIN_SESS_EXPIR"),
        type: "warning",
        duration: 10000
      });
    }
  }
};
</script>

<style lang="scss" scoped>
// scoped 를 풀었을경우, 강사 로그인 - 내 강의 목록 - 강의 개설 이동시 폰트가 커지는 버그가 있음. 해당 화면 새로고침시 다시 작아짐..
.el-input {
  margin: 10px;
}

#btn_login {
  margin: 0 20px 0 100px;
  width: 150px;
}

#login_wrapper {
  margin-top: 70px;
  padding-left: 100px;
}

#login_wrapper h1 {
  margin: 0.67em 15px;
}

.el-form-item label {
  font-size: 1.2em;
  margin-left: 10px;
  padding-bottom: 0px;
}

#login_wrapper-phone {
  margin-top: 70px;
}

#btn_login-phone {
  margin: 0 20px 0 20px;
  width: 100px;
}
</style>
